# NOTE: "hgrev" and Version should match, e.g.
# revision 82ace14bb612 is tagged as "release_v2.09.1" in
# https://bitbucket.org/eliben/pycparser

%global hgrev 82ace14bb612

Name:           python-pycparser
Version:        2.09.1
Release:        3%{?dist}
Summary:        C parser and AST generator written in Python

License:        BSD
URL:            https://bitbucket.org/eliben/pycparser
# tarball generated by bitbucket from mercurial tag:
# https://bitbucket.org/eliben/pycparser/commits/%{hgrev}
Source0:        eliben-pycparser-%{hgrev}.tar.bz2
Source1:        remove-relative-sys-path
# https://bitbucket.org/eliben/pycparser/pull-request/2/tests-all_testspy-add-local-paths-to-the/diff
Patch0:         pycparser-unittests-sys-path.patch
# todo: submit upstream
Patch1:         disable_embedded_ply.patch

BuildArch:      noarch

BuildRequires:  python2-devel
# for unit tests
BuildRequires:  python-ply
BuildRequires:  dos2unix

Requires:  python-ply

%description
pycparser is a complete parser for the C language, written in pure Python.
It is a module designed to be easily integrated into applications that
need to parse C source code.

%prep
%setup -q -n eliben-pycparser-%{hgrev}
%patch0 -p1 -b .orig
%patch1 -p1 -b .orig
# option -b creates backup files to preserve a copy of the original file
# option -p0 ensures the filenames as mentioned in the patch are used
# without removing leading slashes (see man patch for details)

# remove embedded copy of ply
rm -rf pycparser/ply

# examples
cp %SOURCE1 .
./remove-relative-sys-path examples
dos2unix LICENSE

%build
%{__python} setup.py build
cd build/lib/pycparser
%{__python} _build_tables.py

%install
%{__python} setup.py install --skip-build --root %{buildroot}

%check
%{__python} tests/all_tests.py 
 
%files
%doc examples LICENSE
%{python_sitelib}/pycparser/
%{python_sitelib}/pycparser-*.egg-info

%changelog
* Sun Jul 21 2013 Eric Smith <brouhaha@fedoraproject.org> 2.09.1-3
- Run _build_tables.py to build the lextab.py and yacctab.py; otherwise
  they have to be regenerated at runtime for no benefit.

* Tue Mar 19 2013 Jos de Kloe <josdekloe@gmail.com> 2.09.1-2
- remove the embedded ply code

* Fri Jan 18 2013 Scott Tsai <scottt.tw@gmail.com> 2.09.1-1
- upstream 2.09.1
